## Step 1: Understanding the Problem
In this assignment, you're given two classes: IndexSearch and IndexBuilder. IndexSearch contains the main method for the program and provides implementations for an index-based search over a CSV of book-review entries. IndexBuilder is the class that you will implement that builds a primary key index (an array of SimpleEntry<String, Integer>) objects and a second level index (an array of String values) on top of that primary key index.

The SimpleEntry class is an inner class of the AbstractMap class—import java.util.AbstractMap.SimpleEntry; makes it available for you to use.

## Step 2: Implement buildPrimaryKeyIndex
Given a BufferedReader over a .csv file, read each line in the file, extract from each line the ID for the book (the first column), and create a SimpleEntry<String, Integer> mapping the ID (as a String) to the row number from the .csv file. Assume that the header row, which you will skip, is row 0, so the first book appears on row 1. Return an array of these SimpleEntry objects in increasing sorted order based on the keys. This is a sorted, linear, primary key index.

For books_short.csv, you should return:

```
25002982=2
399262=1
703163=3
```
Due to the way that Java deals with generics and arrays, it's probably easier to build the linear index first as a List, and then sort it and convert it to an array afterwards.

## Step 3: Implement buildSecondLevelIndex
Given a primary key index and a block size, create a second level index. The block size indicates how many entries are represented in each block. If we call `buildSecondLevelIndex(primaryKeyIndex, 50)` and get the output array `["10572", "2767052", "35259559", "41940334", "57851735"]`, then there are 50 keys in the primary key index between `["10572", "2767052")`, inclusive on the left and exclusive on the right. Similarly, there are 50 keys between `["2767052", "35259559")`. The only exception is that there are at most, but maybe not as many as, 50 keys following the last entry, "57851735".

The return type of the second level index will be `String[]`, since the keys that we're searching over are Strings.

## Step 4: Test & Verify
In theory, doing the above two steps correctly means that you can now pass all of the tests. The "primary" and "secondary" tests check the literal results of your methods. The "check" test verifies that our program for searching for a record using a primary key succeeds using the second level index that you've built.

**PLEASE UPLOAD THE .CSV FILES ALONG WITH YOUR SUBMISSION!**